## gfal2 2.18.0

=== CMakeLists.txt ===
## cmake build script for srm-ifce
project (gfal2)
cmake_minimum_required (VERSION 2.6)
message ("cmake source dir : ${CMAKE_SOURCE_DIR}")

# default set of options
set (MAIN_CORE      TRUE CACHE STRING "enable compilation of the main library")
set (MAIN_TRANSFER  TRUE CACHE STRING "enable compilation of the transfer library")
set (PLUGIN_LFC     TRUE CACHE STRING "enable compilation of the lfc plugin")
set (PLUGIN_SFTP    TRUE CACHE STRING "enable compilation of the sftp plugin")
set (PLUGIN_SRM     TRUE CACHE STRING "enable compilation of the srm plugin")
set (PLUGIN_RFIO    TRUE CACHE STRING "enable compilation of the RFIO plugin")
set (PLUGIN_DCAP    TRUE CACHE STRING "enable compilation of the DCAP plugin")
set (PLUGIN_FILE    TRUE CACHE STRING "enable compilation of the local File plugin")
set (PLUGIN_GRIDFTP TRUE CACHE STRING "enable compilation of the GRIDFTP plugin")
set (PLUGIN_HTTP    TRUE CACHE STRING "enable compilation of the HTTP plugin")
set (PLUGIN_XROOTD  TRUE CACHE STRING "enable compilation of the XROOTD plugin")
set (PLUGIN_MOCK    FALSE CACHE STRING "enable compilation of the MOCK plugin")

# build type
set (CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "type of build")

set (CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules/")

# load modules
include(DefineInstallationPaths REQUIRED)
include(MacroCopyFile REQUIRED)
include(ReleaseDebugAutoFlags REQUIRED)
include(CMakeGeneratePkgConfig REQUIRED)
include(MacroAddDoxygen REQUIRED)
include(CMakeCXX11Support REQUIRED)

# Enable C++11 support
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CXX11_FLAG_ENABLE}")

# enable testing
include (CTest)

#define PROJECT vars
set (PROJECT_NAME_MAIN "gfal2")
set (OUTPUT_NAME_MAIN "gfal2")

set (PROJECT_NAME_TRANSFER "gfal_transfer")
set (OUTPUT_NAME_TRANSFER "gfal_transfer")

set (VERSION_MAJOR  2)
set (VERSION_MINOR  18)
set (VERSION_PATCH  0)
set (VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})

add_definitions(-DVERSION="${VERSION_STRING}")

# out of project test compilation
set (ONLY_TESTS FALSE CACHE STRING "build only the tests")
set (SKIP_TESTS FALSE CACHE STRING "skip the tests")

# libs checks
find_package (GLIB2 REQUIRED)
find_package (GTHREAD2 REQUIRED)
find_package (JSONC REQUIRED)

# include directories
include_directories (${GLIB2_INCLUDE_DIRS})
include_directories (${GTHREAD2_INCLUDE_DIRS})
include_directories (${CMAKE_SOURCE_DIR}/src/core)
include_directories (${CMAKE_SOURCE_DIR}/src/utils)

# Core and plugins
if (NOT ONLY_TESTS)

    # general parameters for configuration
    add_definitions ( -DGFAL_PLUGIN_DIR_DEFAULT="${PLUGIN_INSTALL_DIR}" )
    add_definitions ( -DGFAL_CONFIG_DIR_DEFAULT="${SYSCONF_INSTALL_DIR}" )
    # add file offset 64 for 32 bits
    add_definitions ( -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -D_GNU_SOURCE)

    #install doc license
    install (FILES "LICENSE" "README.md" "RELEASE-NOTES" "DESCRIPTION" "readme.html"
			 DESTINATION ${DOC_INSTALL_DIR})

    # install global configuration files
    list (APPEND lst_conf_files
        "${CMAKE_SOURCE_DIR}/dist/etc/gfal2.d/gfal2_core.conf"
        "${CMAKE_SOURCE_DIR}/dist/etc/gfal2.d/bdii.conf"
        "${CMAKE_SOURCE_DIR}/dist/etc/gfal2.d/x509.conf")
    install (FILES ${lst_conf_files}
             DESTINATION ${SYSCONF_INSTALL_DIR}/gfal2.d/)

    add_subdirectory (doc)
    add_subdirectory (src)

endif (NOT ONLY_TESTS)

if (NOT SKIP_TESTS)
    add_subdirectory (test)
endif (NOT SKIP_TESTS)

## gfal2 2.18.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -45,7 +45,7 @@
 
 set (VERSION_MAJOR  2)
 set (VERSION_MINOR  18)
-set (VERSION_PATCH  0)
+set (VERSION_PATCH  1)
 set (VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
 
 add_definitions(-DVERSION="${VERSION_STRING}")

=== debian/changelog ===
gfal2 (2.18.1-1build1) groovy; urgency=medium

  * No change rebuild against new json-c ABI.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 28 Jul 2020 17:44:21 +0100

gfal2 (2.18.1-1) unstable; urgency=medium

  * New upstream release 2.18.1
  * Drop patch gfal2-json.patch (accepted upstream)

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Tue, 30 Jun 2020 09:34:28 +0200

gfal2 (2.18.0-1) unstable; urgency=medium

  * New upstream release 2.18.0
  * Find json-c using cmake in http plugin build

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Tue, 09 Jun 2020 09:50:34 +0200

gfal2 (2.17.3-1) unstable; urgency=medium

  * New upstream release 2.17.3

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Sun, 03 May 2020 08:39:37 +0200

gfal2 (2.17.2-2) unstable; urgency=medium

  * Remove unused dependencies on libattr1-dev (Closes: #953922)

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Mon, 30 Mar 2020 10:48:20 +0200

gfal2 (2.17.2-1) unstable; urgency=medium

  * New upstream release 2.17.2

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Mon, 02 Mar 2020 08:51:21 +0100

=== debian/control ===
Source: gfal2
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Mattias Ellert <mattias.ellert@physics.uu.se>
Build-Depends:
 debhelper (>= 10),
 cmake,
 doxygen,
 libglib2.0-dev,
 libldap2-dev,
 uuid-dev,
 zlib1g-dev,
 srm-ifce-dev (>= 1.23.1),
 dcap-dev,
 libglobus-gass-copy-dev,
 davix-dev (>= 0.7.6),
 libjson-c-dev,
 libssh2-1-dev,
 pkg-config,
 libgtest-dev (>= 1.8.0-7)
Standards-Version: 4.5.0
Section: net
Vcs-Browser: https://salsa.debian.org/ellert/gfal2
Vcs-Git: https://salsa.debian.org/ellert/gfal2.git
Homepage: https://dmc.web.cern.ch/projects/gfal-2/home

Package: gfal2
Architecture: all
Multi-Arch: foreign
Depends:
 libgfal2-2,
 libgfal-transfer2,
 ${misc:Depends}
Recommends:
 gfal2-plugin-file,
 gfal2-plugin-dcap,
 gfal2-plugin-srm,
 gfal2-plugin-gridftp,
 gfal2-plugin-http,
 gfal2-plugin-sftp
Description: Grid file access library 2.0
 GFAL 2.0 offers an a single and simple POSIX-like API for the file
 operations in grids and cloud environments. The set of supported
 protocols depends on the gfal2 installed plugins.

Package: libgfal2-2
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Replaces:
 gfal2 (<< 2.10.2)
Breaks:
 gfal2 (<< 2.10.2)
Description: Core of the grid file access library 2.0
 The main library of gfal2. The gfal protocol support relies on a
 plugin system.

Package: libgfal-transfer2
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 libgfal2-2 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: File Transfer logic of gfal2
 gfal-transfer is the high level API for file transfer operations in
 gfal2. It supports third-party copy.

Package: libgfal2-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libgfal2-2 (= ${binary:Version}),
 libgfal-transfer2 (= ${binary:Version}),
 libglib2.0-dev,
 ${misc:Depends}
Description: Development files of gfal2
 Development files for gfal2.

Package: gfal2-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends}
Description: Documentation for gfal2
 Documentation, doxygen and examples of gfal2.

Package: gfal2-plugin-file
Architecture: any
Multi-Arch: same
Depends:
 libgfal2-2 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Replaces:
 libgfal2-2 (<< 2.8.4)
Breaks:
 libgfal2-2 (<< 2.8.4)
Description: Provides file support for gfal2
 Provides the file support (file://) for gfal2. The file plugin
 provides local file operations, as copying from local to remote or
 the other way around.

Package: gfal2-plugin-dcap
Architecture: any
Multi-Arch: same
Depends:
 libgfal2-2 (= ${binary:Version}),
 dcap-tunnel-gsi,
 ${shlibs:Depends},
 ${misc:Depends}
Description: Provides dcap support for gfal2
 Provides the dcap support (gsidcap://, dcap://) for gfal2. The dcap
 plugin provides the POSIX operations for the dcap URLs, the dcap
 protocol is used on the DCACHE storage system.

Package: gfal2-plugin-srm
Architecture: any
Multi-Arch: same
Depends:
 libgfal2-2 (= ${binary:Version}),
 libgfal-transfer2 (= ${binary:Version}),
 libgfal-srm-ifce1 (>= 1.23.1),
 ${shlibs:Depends},
 ${misc:Depends}
Description: Provides srm support for gfal2
 Provides the srm support (srm://) for gfal2. The srm plugin provides
 the POSIX operations and the third party transfer support on the SRM
 URLs.

Package: gfal2-plugin-gridftp
Architecture: any
Multi-Arch: same
Depends:
 libgfal2-2 (= ${binary:Version}),
 libgfal-transfer2 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: Provides the gridftp support for gfal2
 Provides the gridftp support (gsiftp://) for gfal2. The gridftp plugin
 provides the POSIX operations and the third party transfer support on
 the GSIFTP URLs.

Package: gfal2-plugin-http
Architecture: any
Multi-Arch: same
Depends:
 libgfal2-2 (= ${binary:Version}),
 libgfal-transfer2 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: Provides HTTP and DAV support for gfal2
 Provides the HTTP (http[s]://) and WebDAV (dav[s]://) support for
 gfal2. This plugin is able to do third-party copy with WebDAV if the
 storage supports it.

Package: gfal2-plugin-sftp
Architecture: any
Multi-Arch: same
Depends:
 libgfal2-2 (= ${binary:Version}),
 libgfal-transfer2 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: Provides sftp support for gfal2
 Provides the sftp (sftp://) support for gfal2.

Package: gfal2-plugin-mock
Architecture: any
Multi-Arch: same
Depends:
 libgfal2-2 (= ${binary:Version}),
 libgfal-transfer2 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: Provides a mock dummy protocol for gfal2
 Provides a dummy mock:// protocol for gfal2.

## gfal2 2.18.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -45,7 +45,7 @@
 
 set (VERSION_MAJOR  2)
 set (VERSION_MINOR  18)
-set (VERSION_PATCH  1)
+set (VERSION_PATCH  2)
 set (VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
 
 add_definitions(-DVERSION="${VERSION_STRING}")

=== test/functional/CMakeLists.txt ===
function (add_test_executable name source)
add_executable(${name} ${source})
install(TARGETS ${name}
        DESTINATION ${SHARE_INSTALL_PREFIX}/gfal2/tests)
endfunction(add_test_executable name)


if(FUNCTIONAL_TESTS)
    find_package(GTEST)

    include_directories(
        "${CMAKE_SOURCE_DIR}/src"
        "${CMAKE_SOURCE_DIR}/test"
        "${CMAKE_SOURCE_DIR}/src/posix/"
        "${GLIB2_INCLUDE_DIRS}"
        "${GTEST_INCLUDE_DIR}"
        "${JSONC_INCLUDE_DIRS}"
    )

    # Bring online tests
    add_test_executable(gfal_test_bringonline "gfal_test_bringonline.cpp")
    target_link_libraries(gfal_test_bringonline ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_bringonline name dir_path)
        add_test(gfal_test_bringonline_${name} gfal_test_bringonline ${dir_path})
    endfunction(test_bringonline name valid_file)

    # Checksum tests
    add_test_executable(gfal_test_checksum "gfal_test_checksum.cpp")
    target_link_libraries(gfal_test_checksum ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_checksum_simple name dir_path algo)
        add_test(gfal_checksum_simple_${name} gfal_test_checksum ${dir_path} ${algo})
    endfunction(test_checksum_simple name valid_file algo)

    # Stat tests
    add_test_executable(gfal_test_stat "gfal_test_stat.cpp")
    target_link_libraries(gfal_test_stat ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_stat_all name valid)
        add_test(gfal_stat_${name} gfal_test_stat ${valid})
    endfunction(test_stat_all valid)

    # Access test
    add_test_executable(gfal_test_access "gfal_test_access.cpp")
    target_link_libraries(gfal_test_access ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_access name dir_path)
        add_test(gfal_test_access_${name} gfal_test_access ${dir_path})
    endfunction(test_access name dir_path)

    # XAttr test
    add_test_executable(gfal_test_xattr "gfal_test_xattr.cpp")
    target_link_libraries(gfal_test_xattr ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_xattr name dir_path)
        add_test(gfal_test_xattr_${name} gfal_test_xattr ${dir_path} ${ARGV2})
    endfunction(test_xattr name dir_path)

    # Deletion tests
    add_test_executable(gfal_test_del "gfal_test_del.cpp")
    target_link_libraries(gfal_test_del ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_del name dir_path)
        add_test(gfal_test_del_${name} gfal_test_del ${dir_path})
    endfunction(test_del name path)
    
    # QoS tests
    add_test_executable(gfal_test_qos "gfal_test_qos.cpp")
    target_link_libraries(gfal_test_qos ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_qos name)
        add_test(gfal_test_qos_${name} gfal_test_qos)
    endfunction(test_qos name)

    # Rename tests
    add_test_executable(gfal_test_rename "gfal_test_rename.cpp")
    target_link_libraries(gfal_test_rename ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_rename name dir_path)
        add_test(gfal_test_rename_${name} gfal_test_rename ${dir_path})
    endfunction(test_rename name dir_path)

    # Chmod tests
    add_test_executable(gfal_test_chmod "gfal_test_chmod.cpp")
    target_link_libraries(gfal_test_chmod ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_chmod_all name valid right1 right2 right3 right4)
        add_test(gfal_test_right_change_${name} gfal_test_chmod ${valid} ${right1} ${right2} ${right3} ${right4})
    endfunction(test_chmod_all name valid right1 right2 right3 right4)

    # Rmdir tests
    add_test_executable(gfal_test_rmdir_full "gfal_test_rmdir_full.cpp")
    target_link_libraries(gfal_test_rmdir_full ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_rmdir_all name valid_dir)
        add_test(gfal_test_rmdir_full_${name} gfal_test_rmdir_full ${valid_dir})
    endfunction(test_rmdir_all name valid_dir)

    # Readdir tests
    add_test_executable(gfal_test_readdir_full "gfal_test_readdir_full.cpp")
    target_link_libraries(gfal_test_readdir_full ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_readdir_full name valid)
            add_test(gfal_test_readdir_full_${name} gfal_test_readdir_full ${valid})
    endfunction(test_readdir_full valid)

    # IO tests
    add_test_executable(gfal_test_rw_full "gfal_test_rw_full.cpp")
    target_link_libraries(gfal_test_rw_full ${GFAL2_LIBRARIES} gfal2_test_shared)

    add_test_executable(gfal_test_rw_seq "gfal_test_rw_seq.cpp")
    target_link_libraries(gfal_test_rw_seq ${GFAL2_LIBRARIES} gfal2_test_shared)

    add_test_executable(gfal_test_rw_seek "gfal_test_rw_seek.cpp")
    target_link_libraries(gfal_test_rw_seek ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_rwt_all name path size)
        add_test(gfal_rw_size_${name} gfal_test_rw_full ${path} ${size})
    endfunction(test_rwt_all name path size)

    function(test_rwt_seq name path size_read size)
        add_test(gfal_rw_seq_${name} gfal_test_rw_seq ${path} ${size_read} ${size})
    endfunction(test_rwt_seq name path size_read size)

    function(test_rwt_seek name path size_read size)
        add_test(gfal_rw_seek_${name} gfal_test_rw_seek ${path} ${size_read} ${size})
    endfunction(test_rwt_seek name path size)

    # Mkdir tests
    add_test_executable(gfal_test_mkdir_full "gfal_test_mkdir_full.cpp")
    target_link_libraries(gfal_test_mkdir_full ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_mkdir_all name prefix)
        add_test(gfal_mkdir_full_${name} gfal_test_mkdir_full ${prefix})
    endfunction(test_mkdir_all name prefix)

    # Register test
    add_test_executable(gfal_test_register "gfal_test_register.cpp")
    target_link_libraries(gfal_test_register ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_register name origin lfc)
        add_test(gfal_test_register_${name} gfal_test_register ${origin} ${lfc})
    endfunction(test_register name origin lfc)

    # Set credentials test
    add_test_executable(gfal_test_set_creds "gfal_test_set_creds.cpp")
    target_link_libraries(gfal_test_set_creds ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(gfal_test_set_credentials name prefix)
        add_test(gfal_test_set_credentials_${name} gfal_test_set_creds ${prefix})
    endfunction(gfal_test_set_credentials name prefix)

    # Posix test
    add_test_executable(gfal_test_posix "gfal_test_posix.cpp")
    target_link_libraries(gfal_test_posix ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(gfal_test_posix name prefix)
        add_test(gfal_test_posix_${name} gfal_test_posix ${prefix})
    endfunction(gfal_test_posix name prefix)

    # Space test
    add_test_executable(gfal_test_space "gfal_test_space.cpp")
    target_link_libraries(gfal_test_space ${GFAL2_LIBRARIES} gfal2_test_shared)
    function(test_space name prefix)
        add_test(gfal_test_space_${name} gfal_test_space ${prefix})
    endfunction(test_space name prefix)

    # Tests for file transfer
    if(MAIN_TRANSFER)

		add_test_executable(gfalt_test_rd3_reorder_protocols "gfalt_test_rd3_reorder_protocols.cpp")
        target_link_libraries(gfalt_test_rd3_reorder_protocols ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} gfal2_test_shared)
        function(test_rd3_reorder_protocols name src_dir dst_dir)
            add_test(rd3_reorder_protocols_${name} gfalt_test_rd3_reorder_protocols ${src_dir} ${dst_dir})
        endfunction(test_rd3_reorder_protocols name dst_dir)

        add_test_executable(gfalt_test_copy_file_cancel "gfalt_test_copy_file_cancel.cpp")
        target_link_libraries(gfalt_test_copy_file_cancel ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} pthread)

        add_test_executable(gfalt_test_copy_file "gfalt_test_copy_file.cpp")
        target_link_libraries(gfalt_test_copy_file ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} gfal2_test_shared)

        add_test_executable(gfalt_test_copy_file_timeout "gfalt_test_copy_file_timeout.cpp")
        target_link_libraries(gfalt_test_copy_file_timeout ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} gfal2_test_shared)

        add_test_executable(gfalt_test_copy_file_mkdir "gfalt_test_copy_file_mkdir.cpp")
        target_link_libraries(gfalt_test_copy_file_mkdir ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} gfal2_test_shared)

        add_test_executable(gfalt_test_copy_file_replace "gfalt_test_copy_file_replace.cpp")
        target_link_libraries(gfalt_test_copy_file_replace ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} gfal2_test_shared)

        add_test_executable(gfalt_test_copy_file_checksum "gfalt_test_copy_file_checksum.cpp")
        target_link_libraries(gfalt_test_copy_file_checksum ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} gfal2_test_shared)

        add_test_executable(gfalt_test_copy_file_checksum_user "gfalt_test_copy_file_checksum_user.cpp")
        target_link_libraries(gfalt_test_copy_file_checksum_user ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} gfal2_test_shared)

        add_test_executable(gfalt_test_copy_bulk "gfalt_test_copy_bulk.cpp")
        target_link_libraries(gfalt_test_copy_bulk ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} gfal2_test_shared)

        add_test_executable(gfalt_test_pasv "gfalt_test_pasv.cpp")
        target_link_libraries(gfalt_test_pasv ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} gfal2_test_shared)

        function(test_copy_file_full name src_dir dst_dir)
            add_test(copyfile_checksum_${name} gfalt_test_copy_file_checksum ${src_dir} ${dst_dir})
            add_test(copyfile_checksum_user_${name} gfalt_test_copy_file_checksum_user ${src_dir} ${dst_dir})
            add_test(copyfile_replace_${name} gfalt_test_copy_file_replace ${src_dir} ${dst_dir})
            add_test(copyfile_test_${name} gfalt_test_copy_file ${src_dir} ${dst_dir})
            add_test(copyfile_test_mkdir_${name} gfalt_test_copy_file_mkdir ${src_dir} ${dst_dir})
        endfunction(test_copy_file_full name dst_dir)

        function (test_copy_bulk name src_dir dst_dir)
            add_test(copyfile_bulk_${name} gfalt_test_copy_bulk ${src_dir} ${dst_dir})
        endfunction (test_copy_bulk name src_dir dst_dir)

        function(test_copy_file_no_checksum name src_dir dst_dir)
            add_test(copyfile_replace_${name} gfalt_test_copy_file_replace ${src_dir} ${dst_dir})
            add_test(copyfile_test_${name} gfalt_test_copy_file ${src_dir} ${dst_dir})
            add_test(copyfile_test_mkdir_${name} gfalt_test_copy_file_mkdir ${src_dir} ${dst_dir})
        endfunction(test_copy_file_no_checksum name src_dir dst_dir)

        function(test_pasv name src_dir dst_dir)
            add_test(gfalt_test_pasv_${name} gfalt_test_pasv ${src_dir} ${dst_dir})
        endfunction(test_pasv name src_dir dst_dir)

        add_test_executable(gfalt_test_double_cred "gfalt_test_double_cred.cpp")
        target_link_libraries(gfalt_test_double_cred ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} gfal2_test_shared)

        function(test_double_cred name src_dir dst_dir)
            add_test(gfalt_test_double_cred_${name} gfalt_test_double_cred ${src_dir} ${dst_dir})
        endfunction(test_double_cred name src_dir dst_dir)

    endif(MAIN_TRANSFER)

    include(functional-test-parameters.cmake)

    include(functional-test-parameters.cmake)

    # Install ctest file
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/CTestTestfile.cmake
            DESTINATION ${SHARE_INSTALL_PREFIX}/gfal2/tests)

endif(FUNCTIONAL_TESTS)

=== debian/changelog ===
gfal2 (2.18.2-1) unstable; urgency=medium

  * New upstream release 2.18.2

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Sun, 09 Aug 2020 15:54:29 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,6 @@
 Source: gfal2
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Mattias Ellert <mattias.ellert@physics.uu.se>
+Maintainer: Mattias Ellert <mattias.ellert@physics.uu.se>
 Build-Depends:
  debhelper (>= 10),
  cmake,

## gfal2 2.19.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -44,8 +44,8 @@
 set (OUTPUT_NAME_TRANSFER "gfal_transfer")
 
 set (VERSION_MAJOR  2)
-set (VERSION_MINOR  18)
-set (VERSION_PATCH  2)
+set (VERSION_MINOR  19)
+set (VERSION_PATCH  0)
 set (VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
 
 add_definitions(-DVERSION="${VERSION_STRING}")

=== packaging/Makefile ===
NAME=gfal2
SPEC=rpm/$(NAME).spec
VERSION=${shell grep '^Version:' $(SPEC) | awk '{print $$2}' }
# Leave blank. To be overriden by CI tools.
RELEASE=

CWD=${shell pwd}

RPMBUILD=/tmp/rpmbuild
SRPMS=$(CWD)
RPMS=$(CWD)/out

MOCK_CHROOT=epel-7-x86_64
MOCK_FLAGS=--verbose


RPMDEFINES_SRC=--define='_topdir $(RPMBUILD)' \
	--define='_sourcedir $(CWD)' \
	--define='_builddir %{_topdir}/BUILD' \
	--define='_srcrpmdir $(SRPMS)' \
	--define='_rpmdir $(RPMS)' \
    --define "_source_filedigest_algorithm md5" \
    $(RPMBUILD_SRC_EXTRA_FLAGS)

RPMDEFINES_BIN=--define='_topdir $(RPMBUILD)' \
	--define='_sourcedir %{_topdir}/SOURCES' \
	--define='_builddir %{_topdir}/BUILD' \
	--define='_srcrpmdir $(SRPMS).' \
	--define='_rpmdir $(RPMS)' \
    --define "_binary_filedigest_algorithm md5" \
    $(RPMBUILD_BIN_EXTRA_FLAGS)


PBUILDER_FLAGS=
PBUILDER_TMP="/tmp/"


all: srpm

clean:
	rm -fv *.tar
	rm -fv *.tar.gz
	rm -fv *.rpm
	rm -fv *.log
	rm -rfv out
	rm -fv *.deb
	rm -fv *.gz
	rm -fv *.dsc
	rm -fv *.changes
	rm -rfv "$(RPMBUILD)"

dist: clean
	tar vczf "$(NAME)-$(VERSION).tar.gz" --exclude="packaging" --exclude=".git" --exclude="*.pyc" --transform="s,^,$(NAME)-$(VERSION)/," ..

$(RPMBUILD):
	mkdir -p "$(RPMBUILD)"

override_release: $(SPEC)
	$(if $(RELEASE), sed -i "s/Release:.*/Release: $(RELEASE)%{?dist}/g" "$(SPEC)")

srpm: dist $(SPEC) $(RPMBUILD) override_release
	/usr/bin/rpmbuild --nodeps -bs $(RPMDEFINES_SRC) $(SPEC)

rpm: srpm
	/usr/bin/rpmbuild --rebuild $(RPMDEFINES_BIN) $(NAME)-$(VERSION)-*.src.rpm

mock: srpm
	/usr/bin/mock $(MOCK_FLAGS) -r $(MOCK_CHROOT) $(NAME)-$(VERSION)-*.src.rpm

deb-src: dist
	rm -rf "$(PBUILDER_TMP)/$(NAME)-$(VERSION)"
	tar xzf "$(NAME)-$(VERSION).tar.gz" -C "$(PBUILDER_TMP)"
	cp -rv debian "$(PBUILDER_TMP)/$(NAME)-$(VERSION)"
	$(if $(RELEASE), sed -ri "s/($(NAME) )\((([0-9]+\.)+[0-9]+)-[0-9]+\)/\\1(\\2-$(RELEASE))/g" "$(PBUILDER_TMP)/$(NAME)-$(VERSION)/debian/changelog")
	cp -f "$(NAME)-$(VERSION).tar.gz" "$(PBUILDER_TMP)/$(NAME)_$(VERSION).orig.tar.gz" 
	cd "$(PBUILDER_TMP)/$(NAME)-$(VERSION)"; \
		debuild -us -uc -S
	mv $(PBUILDER_TMP)/$(NAME)_$(VERSION)*.gz .
	mv $(PBUILDER_TMP)/$(NAME)_$(VERSION)*.dsc .

deb: deb-src
	pbuilder build $(PBUILDER_FLAGS) $(NAME)_$(VERSION)*.dsc

=== doc/examples/Makefile ===
# Makefile for all the examples

all_examples:=$(shell find -iname "*.c")

CFLAGS:=$(shell pkg-config --libs --cflags gfal2) $(shell pkg-config --libs --cflags gfal_transfer)
OBJS=$(all_examples:%.c=%)

all: $(OBJS)

clean:
	$(RM) $(OBJS)

=== src/core/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

# Sources needed for the core library
file (GLOB src_cancel     "cancel/*.c*")
file (GLOB src_common     "common/*.c" "future/*.c")
file (GLOB src_config     "config/*.c")
file (GLOB src_exceptions "exceptions/*.c*")
file (GLOB src_gconfig    "g_config_manager/*.c*")
file (GLOB src_file       "file/*.c*")
file (GLOB src_global     "global/*c*")
file (GLOB src_logger     "logger/*.c*")
file (GLOB src_posix      "posix/*.c*")

# Core library
add_definitions(-D__GFAL2_BUILD__)

include_directories(${gfal2_utils_includes})

add_definitions (${gfal2_utils_definitions})
add_library (gfal2 SHARED ${src_cancel}
                          ${src_common}
                          ${src_config}
                          ${src_gconfig}
                          ${src_file}
                          ${src_global}
                          ${src_logger}
                          ${src_posix}
                          ${src_exceptions}
                          ${gfal2_utils_c_src})

target_link_libraries (gfal2 "stdc++" ) # hotfix for libc TLS init bug in EPEL 5
target_link_libraries (gfal2 ${GLIB2_PKG_LIBRARIES} ${GTHREAD2_PKG_LIBRARIES})
target_link_libraries (gfal2 "dl")
target_link_libraries (gfal2 ${gfal2_utils_libraries})

set_target_properties (gfal2 PROPERTIES
                             VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}
                             SOVERSION ${VERSION_MAJOR}
                             CLEAN_DIRECT_OUTPUT 1
                             OUTPUT_NAME ${OUTPUT_NAME_MAIN})

# pkgconfig for gfal2
add_PkgConfigFile_for_Library ("gfal2.pc" gfal2
                                        HEADER_DIRS "gfal2"
                                        CFLAGS " -D_FILE_OFFSET_BITS=64 "
                                        DESCRIPTION "GFAL 2.0 pkgconfig file"
                                        REQUIRES "glib-2.0")

# Install core library
install (TARGETS gfal2 LIBRARY DESTINATION ${LIB_INSTALL_DIR})
install (FILES ${CMAKE_CURRENT_BINARY_DIR}/gfal2.pc DESTINATION ${PKGCONFIG_FILES_DIR})

# Install development headers
install (FILES "gfal_api.h" "gfal_plugins_api.h"
         DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/)
install (FILES "logger/gfal_logger.h"
         DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/logger)
install (FILES "posix/gfal_posix_api.h"
         DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/posix)
install (FILES "common/gfal_cancel.h"
               "common/gfal_common.h"
               "common/gfal_config.h"
               "common/gfal_constants.h"
               "common/gfal_cred_mapping.h"
               "common/gfal_deprecated.h"
               "common/gfal_error.h"
               "common/gfal_plugin.h"
               "common/gfal_file_handle.h"
               "common/gfal_plugin_interface.h"
         DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/common)
install (FILES "file/gfal_file_api.h"
         DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/file)

# Transfer library
if (MAIN_TRANSFER)
    add_subdirectory (transfer)
endif (MAIN_TRANSFER)

=== src/plugins/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

link_directories(${CMAKE_CURRENT_BINARY_DIR}/../core)

add_subdirectory (dcap)
add_subdirectory (file)
add_subdirectory (gridftp)
add_subdirectory (http)
add_subdirectory (lfc)
add_subdirectory (rfio)
add_subdirectory (sftp)
add_subdirectory (srm)
add_subdirectory (xrootd)
add_subdirectory (mock)

=== test/functional/CMakeLists.txt ===
--- 
+++ 
@@ -25,6 +25,14 @@
         add_test(gfal_test_bringonline_${name} gfal_test_bringonline ${dir_path})
     endfunction(test_bringonline name valid_file)
 
+    # Archive tests
+    add_test_executable(gfal_test_archive "gfal_test_archive.cpp")
+    target_link_libraries(gfal_test_archive ${GFAL2_LIBRARIES} gfal2_test_shared)
+
+    function(test_archive name dir_path)
+        add_test(gfal_test_archive_${name} gfal_test_archive ${dir_path})
+    endfunction(test_archive name dir_path)
+
     # Checksum tests
     add_test_executable(gfal_test_checksum "gfal_test_checksum.cpp")
     target_link_libraries(gfal_test_checksum ${GFAL2_LIBRARIES} gfal2_test_shared)

=== test/unit/CMakeLists.txt ===
include_directories(
    "${CMAKE_SOURCE_DIR}/test"
    "${CMAKE_SOURCE_DIR}/src/posix/"
)

add_subdirectory(cancel)
add_subdirectory(config)
add_subdirectory(cred)
add_subdirectory(global)
add_subdirectory(mds)
add_subdirectory(transfer)
add_subdirectory(uri)

=== src/core/transfer/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

if (MAIN_TRANSFER)
        file (GLOB src_trans "*.c")
        list (APPEND header_transfer
            "gfal_transfer.h"
            "gfal_transfer_plugins.h"
        )

        add_definitions( ${GLIB2_PKG_CFLAGS} ${GTHREAD2_PKG_CFLAGS})

        add_library(gfal2_transfer  SHARED ${src_trans} ${gfal2_utils_src})
        target_link_libraries(gfal2_transfer ${GLIB2_PKG_LIBRARIES} ${GTHREAD2_PKG_LIBRARIES})
        target_link_libraries(gfal2_transfer ${UUID_PKG_LIBRARIES} ${OUTPUT_NAME_MAIN})

        set_target_properties(gfal2_transfer PROPERTIES
                                     LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/src/core
                                     VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}
                                     SOVERSION ${VERSION_MAJOR}
                                     CLEAN_DIRECT_OUTPUT 1
                                     OUTPUT_NAME "gfal_transfer")
        add_PkgConfigFile_for_Library("gfal_transfer.pc" gfal2_transfer
                                       HEADER_DIRS "gfal2"
                                       DESCRIPTION "gfal_transfer pkgconfig file"
                                       REQUIRES "gfal2")

        install(TARGETS gfal2_transfer
        LIBRARY DESTINATION ${LIB_INSTALL_DIR} )

        install(FILES ${CMAKE_CURRENT_BINARY_DIR}/gfal_transfer.pc DESTINATION ${PKGCONFIG_FILES_DIR})
        install(FILES ${header_transfer} DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/transfer)

endif (MAIN_TRANSFER)

=== src/plugins/http/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)


if (PLUGIN_HTTP)
    include     (CheckLibraryExists)

    find_package(Davix REQUIRED)

    # Includes
    include_directories (${CMAKE_CURRENT_BINARY_DIR})
    include_directories(${DAVIX_INCLUDE_DIR})
    include_directories(${JSONC_INCLUDE_DIRS})

    # definitions
    add_definitions (${DAVIX_CFLAGS})

    # Build plugin
    file (GLOB src_http "gfal_http_*.cpp")
    add_library (plugin_http MODULE ${src_http})

    target_link_libraries(plugin_http gfal2
          gfal2_transfer
          ${DAVIX_LIBRARIES}
	  ${JSONC_LIBRARIES}
    )

    set_target_properties(plugin_http   PROPERTIES  CLEAN_DIRECT_OUTPUT 1
                                        OUTPUT_NAME "gfal_plugin_http"
                                        LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/plugins)

    # Install
    install(TARGETS plugin_http
            LIBRARY DESTINATION ${PLUGIN_INSTALL_DIR})
    install(FILES "README_PLUGIN_HTTP"
            DESTINATION ${DOC_INSTALL_DIR})    

    # install http configuration files
    LIST(APPEND http_conf_file "${CMAKE_SOURCE_DIR}/dist/etc/gfal2.d/http_plugin.conf")
    install(FILES ${http_conf_file}
                        DESTINATION ${SYSCONF_INSTALL_DIR}/gfal2.d/)

endif (PLUGIN_HTTP)

=== test/unit/cancel/CMakeLists.txt ===
file (GLOB src_test_cancel "*.c*")

add_executable(unit_test_transfer_cancel_exe
    ${src_test_cancel}
)

target_link_libraries(unit_test_transfer_cancel_exe
    ${GFAL2_LIBRARIES} ${GTEST_LIBRARIES} ${GTEST_MAIN_LIBRARIES} m
)

add_test(unit_test_transfer_cancel unit_test_transfer_cancel_exe)

=== test/unit/mds/CMakeLists.txt ===

find_package (PugiXML)
if (PUGIXML_FOUND)
    add_executable(mds_test "test_mds.cpp")

    target_link_libraries(mds_test
        ${GFAL2_LIBRARIES} ${GTEST_LIBRARIES} ${GTEST_MAIN_LIBRARIES}
    )

    add_test(mds_test mds_test)
endif (PUGIXML_FOUND)

=== debian/changelog ===
gfal2 (2.19.0-3) unstable; urgency=medium

  * Change to debhelper compat level 13
  * Remove override_dh_missing rule (--fail-missing is default)
  * Drop ancient Replaces/Breaks
  * Put back dependencies on libattr1-dev for kfreebsd-any
    The gfal2 code uses <sys/xattr.h> if glibc >= 2.27, otherwise
    <attr/xattr.h>, and kfreebsd still uses glibc 2.25. There is a
    <sys/xattr.h> available, but gfal2 does not use it due to the
    version check.

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Sun, 03 Jan 2021 19:10:28 +0100

gfal2 (2.19.0-2) unstable; urgency=medium

  * Reupload source only

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Mon, 14 Dec 2020 10:31:19 +0100

gfal2 (2.19.0-1) unstable; urgency=medium

  * New upstream release 2.19.0
  * Build xrootd plugin (xrootd is now in debian)

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Fri, 11 Dec 2020 09:50:39 +0100

=== debian/control ===
--- 
+++ 
@@ -2,26 +2,29 @@
 Priority: optional
 Maintainer: Mattias Ellert <mattias.ellert@physics.uu.se>
 Build-Depends:
- debhelper (>= 10),
+ debhelper (>= 13),
  cmake,
  doxygen,
+ libattr1-dev [kfreebsd-any],
  libglib2.0-dev,
+ libjson-c-dev,
  libldap2-dev,
+ libpugixml-dev,
  uuid-dev,
  zlib1g-dev,
  srm-ifce-dev (>= 1.23.1),
  dcap-dev,
  libglobus-gass-copy-dev,
  davix-dev (>= 0.7.6),
- libjson-c-dev,
+ libxrootd-client-dev,
  libssh2-1-dev,
  pkg-config,
  libgtest-dev (>= 1.8.0-7)
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Section: net
 Vcs-Browser: https://salsa.debian.org/ellert/gfal2
 Vcs-Git: https://salsa.debian.org/ellert/gfal2.git
-Homepage: https://dmc.web.cern.ch/projects/gfal-2/home
+Homepage: https://dmc-docs.web.cern.ch/dmc-docs/gfal2/gfal2.html
 
 Package: gfal2
 Architecture: all
@@ -36,6 +39,7 @@
  gfal2-plugin-srm,
  gfal2-plugin-gridftp,
  gfal2-plugin-http,
+ gfal2-plugin-xrootd,
  gfal2-plugin-sftp
 Description: Grid file access library 2.0
  GFAL 2.0 offers an a single and simple POSIX-like API for the file
@@ -49,10 +53,6 @@
 Depends:
  ${shlibs:Depends},
  ${misc:Depends}
-Replaces:
- gfal2 (<< 2.10.2)
-Breaks:
- gfal2 (<< 2.10.2)
 Description: Core of the grid file access library 2.0
  The main library of gfal2. The gfal protocol support relies on a
  plugin system.
@@ -76,6 +76,7 @@
 Depends:
  libgfal2-2 (= ${binary:Version}),
  libgfal-transfer2 (= ${binary:Version}),
+ libattr1-dev [kfreebsd-any],
  libglib2.0-dev,
  ${misc:Depends}
 Description: Development files of gfal2
@@ -97,10 +98,6 @@
  libgfal2-2 (= ${binary:Version}),
  ${shlibs:Depends},
  ${misc:Depends}
-Replaces:
- libgfal2-2 (<< 2.8.4)
-Breaks:
- libgfal2-2 (<< 2.8.4)
 Description: Provides file support for gfal2
  Provides the file support (file://) for gfal2. The file plugin
  provides local file operations, as copying from local to remote or
@@ -159,6 +156,17 @@
  gfal2. This plugin is able to do third-party copy with WebDAV if the
  storage supports it.
 
+Package: gfal2-plugin-xrootd
+Architecture: any
+Multi-Arch: same
+Depends:
+ libgfal2-2 (= ${binary:Version}),
+ libgfal-transfer2 (= ${binary:Version}),
+ ${shlibs:Depends},
+ ${misc:Depends}
+Description: Provides xrootd support for gfal2
+ Provides the xrootd (root://) support for gfal2.
+
 Package: gfal2-plugin-sftp
 Architecture: any
 Multi-Arch: same

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DSYSCONF_INSTALL_DIR:PATH=/etc \
	   -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" \
	   -DUNIT_TESTS=TRUE -DPLUGIN_MOCK=TRUE \
	   -DPLUGIN_LFC=FALSE -DPLUGIN_RFIO=FALSE

override_dh_auto_build:
	dh_auto_build -- all doc

override_dh_auto_install:
	dh_auto_install
	mkdir -p debian/gfal2-doc/usr/share/doc/gfal2-doc
	mv debian/tmp/usr/share/doc/gfal2/examples \
	   debian/tmp/usr/share/doc/gfal2/html \
	   debian/gfal2-doc/usr/share/doc/gfal2-doc
	rm -rf debian/tmp/usr/share/doc
	# Replace with a script for multi-arch
	printf '#!/bin/sh\necho ' > debian/tmp/usr/bin/gfal2_version.sh
	LD_LIBRARY_PATH=$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH):$${LD_LIBRARY_PATH} \
	   debian/tmp/usr/bin/gfal2_version >> \
	   debian/tmp/usr/bin/gfal2_version.sh
	mv debian/tmp/usr/bin/gfal2_version.sh \
	   debian/tmp/usr/bin/gfal2_version

override_dh_strip:
	dh_strip --dbgsym-migration='gfal2-dbg (<< 2.15.2)'

override_dh_auto_test:
	objdir=obj-$(DEB_HOST_GNU_TYPE) ; \
	export GFAL_PLUGIN_DIR=$(CURDIR)/$${objdir}/plugins ; \
	export GFAL_CONFIG_DIR=$(CURDIR)/$${objdir}/test/conf_test ; \
	dh_auto_test -- "ARGS+=-V"

## gfal2 2.20.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -44,7 +44,7 @@
 set (OUTPUT_NAME_TRANSFER "gfal_transfer")
 
 set (VERSION_MAJOR  2)
-set (VERSION_MINOR  19)
+set (VERSION_MINOR  20)
 set (VERSION_PATCH  0)
 set (VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})

=== test/unit/CMakeLists.txt ===
--- 
+++ 
@@ -10,3 +10,32 @@
 add_subdirectory(mds)
 add_subdirectory(transfer)
 add_subdirectory(uri)
+
+
+add_executable(gfal2-unit-tests
+
+    ./cancel/cancel_tests.cpp
+    ./config/config_test.cpp
+    ./cred/test_cred.cpp
+    ./global/global_test.cpp
+    ./mds/test_mds.cpp
+    ./transfer/tests_callbacks.cpp
+    ./transfer/tests_params.cpp
+    ./uri/test_uri.cpp
+)
+
+target_include_directories(gfal2-unit-tests PRIVATE
+    ${CMAKE_SOURCE_DIR}/test
+    ${PROJECT_SOURCE_DIR}/src
+    ${CMAKE_CURRENT_SOURCE_DIR}
+)
+
+
+target_link_libraries(gfal2-unit-tests
+    ${GFAL2_LIBRARIES} ${GTEST_LIBRARIES} ${GTEST_MAIN_LIBRARIES} gfal2_test_shared
+)
+
+install(TARGETS gfal2-unit-tests
+  DESTINATION ${BIN_INSTALL_DIR}/)
+
+add_test(unit-tests gfal2-unit-tests)

## gfal2 2.20.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -45,7 +45,7 @@
 
 set (VERSION_MAJOR  2)
 set (VERSION_MINOR  20)
-set (VERSION_PATCH  0)
+set (VERSION_PATCH  1)
 set (VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
 
 add_definitions(-DVERSION="${VERSION_STRING}")

## gfal2 2.20.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -45,7 +45,7 @@
 
 set (VERSION_MAJOR  2)
 set (VERSION_MINOR  20)
-set (VERSION_PATCH  1)
+set (VERSION_PATCH  2)
 set (VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
 
 add_definitions(-DVERSION="${VERSION_STRING}")

## gfal2 2.20.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -45,7 +45,7 @@
 
 set (VERSION_MAJOR  2)
 set (VERSION_MINOR  20)
-set (VERSION_PATCH  2)
+set (VERSION_PATCH  3)
 set (VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
 
 add_definitions(-DVERSION="${VERSION_STRING}")

=== test/functional/CMakeLists.txt ===
--- 
+++ 
@@ -81,6 +81,14 @@
         add_test(gfal_test_qos_${name} gfal_test_qos)
     endfunction(test_qos name)
 
+    # Token tests
+    add_test_executable(gfal_test_token "gfal_test_token.cpp")
+    target_link_libraries(gfal_test_token ${GFAL2_LIBRARIES} gfal2_test_shared)
+
+    function(test_token name)
+      add_test(gfal_test_token_${name} gfal_test_token)
+    endfunction(test_token name)
+
     # Rename tests
     add_test_executable(gfal_test_rename "gfal_test_rename.cpp")
     target_link_libraries(gfal_test_rename ${GFAL2_LIBRARIES} gfal2_test_shared)

=== test/unit/CMakeLists.txt ===
--- 
+++ 
@@ -7,13 +7,12 @@
 add_subdirectory(config)
 add_subdirectory(cred)
 add_subdirectory(global)
+add_subdirectory(http)
 add_subdirectory(mds)
 add_subdirectory(transfer)
 add_subdirectory(uri)
 
-
 add_executable(gfal2-unit-tests
-
     ./cancel/cancel_tests.cpp
     ./config/config_test.cpp
     ./cred/test_cred.cpp
@@ -30,7 +29,6 @@
     ${CMAKE_CURRENT_SOURCE_DIR}
 )
 
-
 target_link_libraries(gfal2-unit-tests
     ${GFAL2_LIBRARIES} ${GTEST_LIBRARIES} ${GTEST_MAIN_LIBRARIES} gfal2_test_shared
 )

=== src/plugins/xrootd/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

if (PLUGIN_XROOTD)

    find_package(XROOTD REQUIRED)

    include_directories(${XROOTD_INCLUDE_DIR} ${JSONC_INCLUDE_DIRS})

    file (GLOB src_xrootd "*.cpp")

    add_library (plugin_xrootd MODULE ${src_xrootd})
    add_library (plugin_xrootd_static STATIC ${src_xrootd})
    
    target_link_libraries (plugin_xrootd
        ${GFAL2_PKG_LIBRARIES}
        gfal2_transfer
        ${XROOTD_LIBRARIES}
        ${JSONC_LIBRARIES}
    )
    target_link_libraries(plugin_xrootd_static
        ${GFAL2_PKG_LIBRARIES}
        gfal2_transfer
        ${XROOTD_LIBRARIES}
        ${JSONC_LIBRARIES}
    )
    
    set_target_properties(plugin_xrootd PROPERTIES
                          CLEAN_DIRECT_OUTPUT 1
                          OUTPUT_NAME "gfal_plugin_xrootd"
                          LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/plugins)

    install(TARGETS plugin_xrootd
            LIBRARY DESTINATION ${PLUGIN_INSTALL_DIR})

    # install xrootd configuration files
    list (APPEND xrootd_conf_file "${CMAKE_SOURCE_DIR}/dist/etc/gfal2.d/xrootd_plugin.conf")
    install(FILES ${xrootd_conf_file}
            DESTINATION ${SYSCONF_INSTALL_DIR}/gfal2.d/)
            
    # readme
    install(FILES "README_PLUGIN_XROOTD"
            DESTINATION ${DOC_INSTALL_DIR})

endif ()

=== test/unit/http/CMakeLists.txt ===
add_executable(gfal2_token_map_test "test_token_map.cpp")

find_package(Davix REQUIRED)
find_package(JSONC REQUIRED)

file(GLOB src_http "${CMAKE_SOURCE_DIR}/src/plugins/http/gfal_http_*.cpp")
add_library(test_plugin_http STATIC ${src_http})

target_link_libraries(test_plugin_http
  gfal2
  ${DAVIX_LIBRARIES}
  ${JSONC_LIBRARIES})

target_include_directories(test_plugin_http PRIVATE
  ${DAVIX_INCLUDE_DIR}
  ${JSONC_INCLUDE_DIRS})

target_link_libraries(gfal2_token_map_test
  ${GFAL2_LIBRARIES}
  ${GTEST_LIBRARIES}
  ${GTEST_MAIN_LIBRARIES}
  gfal2_test_shared
  ${DAVIX_LIBRARIES}
  test_plugin_http)

target_include_directories(gfal2_token_map_test PRIVATE
  ${DAVIX_INCLUDE_DIR})

add_test(gfal2_token_map_test gfal2_token_map_test)

=== debian/changelog ===
gfal2 (2.20.3-1) unstable; urgency=medium

  * New upstream release 2.20.3

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Tue, 08 Feb 2022 17:35:14 +0100

gfal2 (2.20.2-2) unstable; urgency=medium

  * Define ENOSR and ENODATA if not defined (kfreebsd)

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Tue, 14 Dec 2021 22:56:09 +0100

gfal2 (2.20.2-1) unstable; urgency=medium

  * New upstream release 2.20.2
  * Drop patch gfal2-dox-group.patch (accepted upstream)

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Tue, 07 Dec 2021 11:20:13 +0100

gfal2 (2.20.1-1) unstable; urgency=medium

  * New upstream release 2.20.1
  * Do not hardcode Linux error numbers

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Wed, 03 Nov 2021 18:21:03 +0100

gfal2 (2.20.0-1) unstable; urgency=medium

  * New upstream release 2.20.0

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Mon, 27 Sep 2021 16:44:04 +0200

gfal2 (2.19.2-1) unstable; urgency=medium

  * New upstream release 2.19.2
  * Drop obsolete patch gfal2-linking.patch
    (fixes LFC and RFIO plugins that we no longer build)
  * Remove override_dh_strip rule (completed debug symbol migration)

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Tue, 24 Aug 2021 14:30:54 +0200

=== debian/control ===
--- 
+++ 
@@ -15,12 +15,12 @@
  srm-ifce-dev (>= 1.23.1),
  dcap-dev,
  libglobus-gass-copy-dev,
- davix-dev (>= 0.7.6),
+ davix-dev (>= 0.8.0),
  libxrootd-client-dev,
  libssh2-1-dev,
  pkg-config,
  libgtest-dev (>= 1.8.0-7)
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Section: net
 Vcs-Browser: https://salsa.debian.org/ellert/gfal2
 Vcs-Git: https://salsa.debian.org/ellert/gfal2.git

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	   -DSYSCONF_INSTALL_DIR:PATH=/etc \
	   -DLIB_SUFFIX:PATH="/$(DEB_HOST_MULTIARCH)" \
	   -DUNIT_TESTS:BOOL=TRUE \
	   -DPLUGIN_MOCK:BOOL=TRUE \
	   -DPLUGIN_LFC:BOOL=FALSE \
	   -DPLUGIN_RFIO:BOOL=FALSE

override_dh_auto_build:
	dh_auto_build -- all doc

override_dh_auto_install:
	dh_auto_install
	# Remove
	rm debian/tmp/usr/share/doc/gfal2/LICENSE
	rm debian/tmp/usr/share/doc/gfal2/readme.html
	rm debian/tmp/usr/bin/gfal2-unit-tests
	rm debian/tmp/usr/lib/*/libgfal2_test_shared.so
	# Replace with a script for multi-arch
	printf '#!/bin/sh\necho ' > debian/tmp/usr/bin/gfal2_version.sh
	LD_LIBRARY_PATH=$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH):$${LD_LIBRARY_PATH} \
	   debian/tmp/usr/bin/gfal2_version >> \
	   debian/tmp/usr/bin/gfal2_version.sh
	mv debian/tmp/usr/bin/gfal2_version.sh \
	   debian/tmp/usr/bin/gfal2_version

override_dh_auto_test:
	objdir=obj-$(DEB_HOST_GNU_TYPE) ; \
	export GFAL_PLUGIN_DIR=$(CURDIR)/$${objdir}/plugins ; \
	export GFAL_CONFIG_DIR=$(CURDIR)/$${objdir}/test/conf_test ; \
	dh_auto_test -- "ARGS+=-V"

## gfal2 2.20.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -45,7 +45,7 @@
 
 set (VERSION_MAJOR  2)
 set (VERSION_MINOR  20)
-set (VERSION_PATCH  3)
+set (VERSION_PATCH  5)
 set (VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
 
 add_definitions(-DVERSION="${VERSION_STRING}")
